package jp.co.sds_corp.hibiya.monitor.checker;

import java.awt.event.ActionEvent;
import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.DaemonManagerChecker;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.daemon.remote.IRemoteClient;

/**
* {@link DaemonManagerChecker}の設定を行うパネルです。
*/
public class DaemonManagerPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	RemotePanel	remPnl = new RemotePanel();
	IRemoteClient	remote;

	public DaemonManagerPanel() {
		testChecker = new DaemonManagerChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( remPnl );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	void test( ActionEvent e ) {
		((DaemonManagerChecker )testChecker).setRemoteClient( remote );
		super.test( e );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		DaemonManagerChecker mon = (DaemonManagerChecker )var;
		IRemoteClient remote = mon.getRemoteClient();
		remPnl.setRemoteClient( remote );
		this.remote = remote;
	}
	public void setupChecker( IChecker var ) throws Exception {
		super.setupChecker( var );
		DaemonManagerChecker mon = (DaemonManagerChecker )var;
		IRemoteClient remote = mon.getRemoteClient();
		remPnl.setupRemoteClient( remote );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		remPnl.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return DaemonManagerChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "RemoteClient" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

