package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.DriveChecker;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link DriveChecker}の設定を行うパネルです。
*/
public class DrivePanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_DRV = new ValuePanel( ValuePanel.ReturnType.STRING, "Drive:" );
	ValuePanel	VAL_MIN = new ValuePanel( ValuePanel.ReturnType.INT, "Minimum:" );

	public DrivePanel() {
		testChecker = new DriveChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_DRV );
		pnl.add( VAL_MIN );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		DriveChecker mon = (DriveChecker )var;
		VAL_DRV.setValue( mon.getDrive() );
		VAL_MIN.setValue( String.valueOf( mon.getMinimum() ));
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		String var = (String )VAL_DRV.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "checker.drive.err1.message" );
			throw( new Exception( msg ));
		}
		Integer nvar = (Integer )VAL_MIN.getValue();
		if ( nvar == null || nvar.intValue() <= 0 ) {
			String msg = res.getString( "checker.drive.err2.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		DriveChecker mon = (DriveChecker )chk;
		mon.setDrive( (String )VAL_DRV.getValue() );
		mon.setMinimum( ((Integer )VAL_MIN.getValue()).intValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_DRV.setEnabled( bEn );
		VAL_MIN.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return DriveChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Drive" ), new Column( "Minimum" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

