package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.NetChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link NetChecker}の設定を行うパネルです。
*/
public class NetPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_ADDR = new ValuePanel( ValuePanel.ReturnType.STRING, "Address:" );
	ValuePanel	VAL_PORT = new ValuePanel( ValuePanel.ReturnType.INT, "Port:" );

	public NetPanel() {
		testChecker = new NetChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_ADDR );
		pnl.add( VAL_PORT );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		NetChecker mon = (NetChecker )var;
		VAL_ADDR.setValue( mon.getAddress() );
		VAL_PORT.setValue( String.valueOf( mon.getPort()) );
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		String var;
		var = (String )VAL_ADDR.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "chcker.net.err1.message" );
			throw( new Exception( msg ));
		}
		Integer nvar = (Integer )VAL_PORT.getValue();
		if ( nvar == null || nvar.intValue() <= 0 ) {
			String msg = res.getString( "chcker.net.err2.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		NetChecker mon = (NetChecker )chk;
		mon.setAddress( (String )VAL_ADDR.getValue() );
		mon.setPort( ((Integer )VAL_PORT.getValue()).intValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_ADDR.setEnabled( bEn );
		VAL_PORT.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return NetChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Address" ), new Column( "Port" ),
		new Column( "ConnectionType" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

