package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.util.daemon.remote.IRemoteClient;
import jp.co.sds_corp.util.daemon.remote.socket.SocketClient;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link IRemoteClient}の設定を行います。
*/
public class RemotePanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel  VAL_REMOTE = new ValuePanel( ValuePanel.ReturnType.STRING, "Remote:" );
	ValuePanel  VAL_HOST = new ValuePanel( ValuePanel.ReturnType.STRING, "Host:" );
	ValuePanel  VAL_PORT = new ValuePanel( ValuePanel.ReturnType.INT, "Port:" );
	ValuePanel  VAL_TOT = new ValuePanel( ValuePanel.ReturnType.INT, "Timeout:" );
	ValuePanel  VAL_RHOST = new ValuePanel( ValuePanel.ReturnType.STRING, "RMI Host:" );
	ValuePanel  VAL_RPORT = new ValuePanel( ValuePanel.ReturnType.INT, "RMI Port:" );
	ValuePanel  VAL_RNAME = new ValuePanel( ValuePanel.ReturnType.STRING, "RMI Name:" );
	ResourceBundle	res;

	public RemotePanel() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		createSetupPanel();
	}

	void createSetupPanel() {
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		add( VAL_REMOTE );
		VAL_REMOTE.setEditable( false );
		add( VAL_HOST );
		add( VAL_PORT );
		add( VAL_TOT );
	}

	void setRemoteClient( IRemoteClient remote ) {
		if ( remote instanceof SocketClient ) {
			SocketClient cli = (SocketClient )remote;
			VAL_HOST.setValue( cli.getHost() );
			VAL_PORT.setValue( String.valueOf( cli.getPort()) );
			VAL_TOT.setValue( String.valueOf( cli.getTimeout()) );
			VAL_HOST.setVisible( true );
			VAL_PORT.setVisible( true );
			VAL_TOT.setVisible( true );
		} else {
			VAL_HOST.setVisible( false );
			VAL_PORT.setVisible( false );
			VAL_TOT.setVisible( false );
		}
		VAL_REMOTE.setValue( remote.toString() );
	}

	void setupRemoteClient( IRemoteClient remote ) throws Exception {
		if ( remote instanceof SocketClient ) {
			String var;
			var = (String )VAL_HOST.getValue();
			if ( var == null || var.length() == 0 ) {
				String msg = res.getString( "checker.remote.err1.message" );
				throw( new Exception( msg ));
			}
			Integer nvar;
			nvar = (Integer )VAL_PORT.getValue();
			if ( nvar == null || nvar.intValue() <= 0 ) {
				String msg = res.getString( "checker.remote.err2.message" );
				throw( new Exception( msg ));
			}
			nvar = (Integer )VAL_TOT.getValue();
			if ( nvar == null || nvar.intValue() <= 0 ) {
				String msg = res.getString( "checker.remote.err3.message" );
				throw( new Exception( msg ));
			}
			SocketClient cli = (SocketClient )remote;
			cli.setHost( (String )VAL_HOST.getValue() );
			cli.setPort( ((Integer )VAL_PORT.getValue()).intValue() );
			cli.setTimeout( ((Integer )VAL_TOT.getValue()).intValue() );
		} else {
			String msg = res.getString( "checker.remote.err1.message" );
			throw( new Exception( msg ));
		}
	}

	public void setEnabled( boolean bEn ) {
		VAL_HOST.setEnabled( bEn );
		VAL_PORT.setEnabled( bEn );
		VAL_TOT.setEnabled( bEn );
		VAL_RHOST.setEnabled( bEn );
		VAL_RPORT.setEnabled( bEn );
		VAL_RNAME.setEnabled( bEn );
	}

}
