package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.WebChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link WebChecker}の設定を行うパネルです。
*/
public class WebPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel VAL_SRV = new ValuePanel( ValuePanel.ReturnType.STRING, "Host:" );
	ValuePanel VAL_PORT = new ValuePanel( ValuePanel.ReturnType.INT, "Port:" );
	ValuePanel VAL_METHOD = new ValuePanel( ValuePanel.ReturnType.STRING, "Method:" );
	ValuePanel VAL_URL = new ValuePanel( ValuePanel.ReturnType.STRING, "URL:" );
	ValuePanel VAL_VER = new ValuePanel( ValuePanel.ReturnType.STRING, "HTTPVersion:" );
	ValuePanel VAL_USR = new ValuePanel( ValuePanel.ReturnType.STRING, "Username:" );
	ValuePanel VAL_PWD = new ValuePanel( ValuePanel.ReturnType.STRING, ValuePanel.Type.PASSWORD, "Password:" );
	ValuePanel VAL_TOUT = new ValuePanel( ValuePanel.ReturnType.INT, "Timeout:" );

	public WebPanel() {
		testChecker = new WebChecker();
		createControls();
	}

	void createControls() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_SRV );
		pnl.add( VAL_PORT );
		pnl.add( VAL_METHOD );
		pnl.add( VAL_URL );
		pnl.add( VAL_VER );
		pnl.add( VAL_USR );
		pnl.add( VAL_PWD );
		pnl.add( VAL_TOUT );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		WebChecker mon = (WebChecker )var;
		VAL_SRV.setValue( mon.getHost() );
		VAL_PORT.setValue( mon.getPort() );
		VAL_METHOD.setValue( mon.getMethod() );
		VAL_URL.setValue( mon.getURL() );
		VAL_VER.setValue( mon.getHTTPVersion() );
		VAL_USR.setValue( mon.getUsername() );
		VAL_PWD.setValue( mon.getPassword() );
		VAL_TOUT.setValue( String.valueOf( mon.getTimeout() ));
	}

	public void checkSetup() throws Exception {
		super.checkSetup();
		if ( VAL_TOUT.getValue() == null ) {
			VAL_TOUT.requestFocus();
			String msg = res.getString( "checker.web.err1.message" );
			throw( new Exception( msg ));
		}
		String var;
		var = (String )VAL_SRV.getValue();
		if ( var == null || var.length() == 0 ) {
			var = (String )VAL_URL.getValue();
			if ( var == null || var.length() == 0 ) {
				String msg = res.getString( "checker.web.err2.message" );
				throw( new Exception( msg ));
			}
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		WebChecker mon = (WebChecker )chk;
		mon.setHost( (String )VAL_SRV.getValue() );
		Integer port = (Integer )VAL_PORT.getValue();
		if ( port == null ) {
			mon.setPort( null );
		} else {
			mon.setPort( port.toString() );
		}
		mon.setMethod( (String )VAL_METHOD.getValue() );
		mon.setURL( (String )VAL_URL.getValue() );
		mon.setHTTPVersion( (String )VAL_VER.getValue() );
		mon.setUsername( (String )VAL_USR.getValue() );
		mon.setPassword( (String )VAL_PWD.getValue() );
		mon.setTimeout( ((Integer )VAL_TOUT.getValue() ).intValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_SRV.setEnabled( bEn );
		VAL_PORT.setEnabled( bEn );
		VAL_METHOD.setEnabled( bEn );
		VAL_URL.setEnabled( bEn );
		VAL_VER.setEnabled( bEn );
		VAL_USR.setEnabled( bEn );
		VAL_PWD.setEnabled( bEn );
		VAL_TOUT.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return WebChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Host" ), new Column( "Port" ), new Column( "Method" ),
		new Column( "URL" ), new Column( "HTTPVersion" ),
		new Column( "Username" ), new Column( "Password", true ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

