package	jp.co.sds_corp.hibiya.monitor.connector;

import javax.swing.BoxLayout;

import jp.co.sds_corp.hibiya.connector.DirectConnector;
import jp.co.sds_corp.hibiya.connector.IConnector;

/**
* {@link DirectConnector}を設定するPanelです。
* @author	小見山　聡
*/
public class DirectPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;

	/**
	* このパネルを初期化します。
	*/
	public DirectPanel() {
		createPanel();
	}

	private void createPanel() {
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		add( VAL_NAME );
		add( VAL_INT );
		add( PNL_BLANK );
	}

	/**
	* 現在の{@link IConnector}を入力された内容で設定します。
	*/
	public void updateConnector() throws Exception {
		String var;
		var = (String )VAL_NAME.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "connector.err4.message" );
			throw( new Exception( msg ));
		}
		Integer nvar;
		nvar = (Integer )VAL_INT.getValue();
		if ( nvar == null || nvar.intValue() <= 0 ) {
			String msg = res.getString( "connector.err5.message" );
			throw( new Exception( msg ));
		}

		super.updateConnector();
	}

}

